Codeforces 901C. Bipartite Segments(思维题)

  擦。。没看见简单环。。已经想的七七八八了,就差一步

  显然我们只要知道一个点最远可以向后扩展到第几个点是二分图,我们就可以很容易地回答每一个询问了,但是怎么求出这个呢。

  没有偶数简单环,相当于只有奇数简单环,没有环套环。因为如果有环套环,必定是两个奇数环合并1个或几个点,也就是同时保持奇数或者同时变为偶数,而我们知道奇数+奇数=偶数,偶数+偶数=偶数,所以就证明了只有奇数简单环,不存在环套环。

  我们现在有一些点,再加入一个点,最多会形成一个环,并且一定是奇环,这时候,编号为1~环上的最小编号的点,最远能扩展到的编号不会超过环上最大编号。所以我们tarjan缩点求出所有环后,把每一个环按照环上最大编号排序,然后从小到大统计每一个点最远能扩展到的点就好了。

#include<iostream>
#include<cstring>
#include<cstdlib>
#include<cstdio>
#include<algorithm>
#define ll long long
using namespace std;
const int maxn=500010, inf=1e9;
struct poi{int too, pre;}e[maxn<<1];
struct tjm{int mx, mn;}q[maxn];
int n, m, x, y, tot, tott, top, color, L, R, Q;
int last[maxn], dfn[maxn], low[maxn], st[maxn], lack[maxn], mx[maxn], mn[maxn], col[maxn], nxt[maxn];
ll sum[maxn], nxtsum[maxn];
inline void read(int &k)
{
    int f=1; k=0; char c=getchar();
    while(c<‘0‘ || c>‘9‘) c==‘-‘ && (f=-1), c=getchar();
    while(c<=‘9‘ && c>=‘0‘) k=k*10+c-‘0‘, c=getchar();
    k*=f;
}
inline void add(int x, int y){e[++tot]=(poi){y, last[x]}; last[x]=tot;}
void tarjan(int x, int fa)
{
    dfn[x]=low[x]=++tott; st[++top]=x; lack[x]=top;
    for(int i=last[x], too;i;i=e[i].pre)
    if((too=e[i].too)!=fa)
    {
        if(!dfn[too=e[i].too]) tarjan(too, x), low[x]=min(low[x], low[too]);
        else if(!col[too]) low[x]=min(low[x], dfn[too]);
    }
    if(dfn[x]==low[x])
    for(q[++color].mn=inf;lack[x]<=top;top--)
    {
        col[st[top]]=color;
        q[color].mx=max(q[color].mx, st[top]);
        q[color].mn=min(q[color].mn, st[top]);
    }
}
inline bool cmp(tjm a, tjm b){return a.mx<b.mx;}
int main()
{
    read(n); read(m);
    for(int i=1;i<=m;i++) read(x), read(y), add(x, y), add(y, x);
    for(int i=1;i<=n;i++) if(!dfn[i]) tarjan(i, 0);
    sort(q+1, q+1+color, cmp);
    int j=1;
    for(int i=1;i<=color;i++)
    if(q[i].mn!=q[i].mx)
    for(;j<=q[i].mn;j++) nxt[j]=q[i].mx-1;
    for(int i=j;i<=n;i++) nxt[i]=n;
    for(int i=1;i<=n;i++) sum[i]=sum[i-1]+nxt[i]-i+1;
    read(Q);
    for(int i=1;i<=Q;i++)
    {
        read(L); read(R);
        int l=L-1, r=R;
        while(l<r)
        {
            int mid=(l+r+1)>>1;
            if(nxt[mid]<=R) l=mid;
            else r=mid-1;
        }
        printf("%lld\n", sum[l]-sum[L-1]+1ll*(R+1)*(R-l)-(1ll*(l+1+R)*(R-l)>>1));
    }
}

原文地址:https://www.cnblogs.com/Sakits/p/8124523.html

时间: 2024-11-08 01:28:18

Codeforces 901C. Bipartite Segments(思维题)的相关文章

Codeforces 901C Bipartite Segments(Tarjan + 二分)

题目链接  Bipartite Segments 题意  给出一个无偶环的图,现在有$q$个询问.求区间$[L, R]$中有多少个子区间$[l, r]$ 满足$L <= l <= r <= R$,并且一个只包含$l$到$r$这些点的无向图为二分图. 因为整张图没有偶环,所以在这道题中如果某个无向图没有环,那个这个无向图就是二分图 Tarjan求出每个环的标号最小点和标号最大点. 令$f[i]$为能保证$[i, j]$这个区间构成的图都是二分图的$j$的最大值,则$f[i]$是不下降的 当

CodeForces 1102C-简单的思维题

题目链接:http://codeforces.com/problemset/problem/1102/C C. Doors Breaking and Repairing time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output You are policeman and you are playing a game with Slavik

Codeforces A. Sweet Problem(思维题)

传送门 题意: 有红,绿,蓝三种颜色的糖各r,g,b个,每天要吃两个糖且颜色不同,问最多能吃多少天 思路: 先把r,g,b排序,从小到大为a,b,c如果a+b<=c,结果肯定输出a+b 否则输出(a+b+c)/2 原因:为了使天数最多,每次取最多和次多的两堆,当次多的变成和最少的相等时,把最多的那个平分个最少和中间那一堆,(如果最多的为奇数,那么总共还剩一个,如果为偶数,所有糖果用完),所以说最优解剩下的糖果不超过两个(a+b>c时) 代码 #include <iostream>

贪心/思维题 Codeforces Round #310 (Div. 2) C. Case of Matryoshkas

题目传送门 1 /* 2 题意:套娃娃,可以套一个单独的娃娃,或者把最后面的娃娃取出,最后使得0-1-2-...-(n-1),问最少要几步 3 贪心/思维题:娃娃的状态:取出+套上(2),套上(1), 已套上(0),先从1开始找到已经套好的娃娃层数, 4 其他是2次操作,还要减去k-1个娃娃是只要套上就可以 5 详细解释:http://blog.csdn.net/firstlucker/article/details/46671251 6 */ 7 #include <cstdio> 8 #i

codeforces 848B Rooter&#39;s Song 思维题

http://codeforces.com/problemset/problem/848/B 给定一个二维坐标系,点从横轴或纵轴垂直于发射的坐标轴射入(0,0)-(w,h)的矩形空间.给出点发射的坐标轴,位置,延迟时间,发生碰撞则交换方向.求最后每个点的射出位置. 首先我们观察能得出两个结论,1. 类似蚂蚁爬树枝的问题,相遇只会交换方向,所以最后的射出点集只会因为碰撞而改变动点与射出点的对应关系,而不会增加减少射出点集.2.我们根据其射入位置和延迟时间可以计算出一个值v=pos-time,只有这

codeforces 895B XK Segments 二分 思维

codeforces 895B XK Segments 题目大意: 寻找符合要求的\((i,j)\)对,有:\[a_i \le a_j \] 同时存在\(k\),且\(k\)能够被\(x\)整除,\(k\)满足:\[a_i \le k \le a_j\] 思路: 整体数组排序,对于当前\(a_i\)寻找符合条件的\(a_j\)的最大值和最小值 有:\[(a_i-1)/x+k=a_j/x\] 所以可以通过二分查找获得,这里我寻找\(((a_i-1)/x+k)*x\)为下界,\(((a_i-1)/x

【CodeForces】901 C. Bipartite Segments

[题目]C. Bipartite Segments [题意]给定n个点m条边的无向连通图,保证不存在偶数长度的简单环.每次询问区间[l,r]中包含多少子区间[x,y]满足只保留[x,y]之间的点和边构成的图是一个二分图. [算法]Tarjan缩点(找环) [题解]如果两个奇数长度的环相交,会得到一个偶数长度的简单环.所以原图是不存在偶数长度环的仙人掌(每条边只属于一个简单环). 二分图的定义:一个图是二分图当且仅当不存在奇数长度的环.在当前仙人掌上,二分图实际上要求选择的点不存在环. 也就是对于

CodeForces 1131B(思维题)

You still have partial information about the score during the historic football match. You are given a set of pairs (ai,bi)(ai,bi), indicating that at some point during the match the score was "aiai: bibi". It is known that if the current score

Codeforces Round #625 (Div. 2, based on Technocup 2020 Final Round) A. Contest for Robots(思维题)

Polycarp is preparing the first programming contest for robots. There are nn problems in it, and a lot of robots are going to participate in it. Each robot solving the problem ii gets pipi points, and the score of each robot in the competition is cal